/* Problem URL: https://codeforces.com/contest/2136/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        ll lim = 1e9;

        V<pair<ll, ll>> fds(n);
        int choice1 = 0;
        ll bestdis1 = INT64_MAX >> 1;
        int choice2 = 0;
        ll bestdis2 = INT64_MAX >> 1;
        rep(i, n) {
            cin >> fds[i].first >> fds[i].second;

            if (abs(2 * lim - fds[i].first) + abs(2 * lim - fds[i].second) <= bestdis1) {
                bestdis1 = abs(2 * lim - fds[i].first) + abs(2 * lim - fds[i].second);
                choice1 = i;
            }

            if (abs(2 * lim - fds[i].first) + abs(2 * (-lim) - fds[i].second) <= bestdis2) {
                bestdis2 = abs(2 * lim - fds[i].first) + abs(2 * (-lim) - fds[i].second);
                choice2 = i;
            }
        }

        auto query = [&](char op) {
            cout << "? " << op << ' ' << lim << endl;
            ll ans;
            cin >> ans;
            return ans;
        };

        query('R');
        query('R');
        query('U');
        ll one = query('U');
        one = one - 4 * lim + fds[choice1].first + fds[choice1].second;

        query('D');
        query('D');
        query('D');
        ll two = query('D');
        two = two - 4 * lim + fds[choice2].first - fds[choice2].second;
        
        ll x = (one + two) / 2;
        ll y = one - x;

        cout << "! " << x << ' ' << y << endl;
    }
}
